#include "GlyphImpl.hh"

#ifdef HAVE_POA_CURRENT
extern PortableServer::Current_var poacurrent;
#endif


GlyphImpl::GlyphImpl ()
{
  body_ = Fresco::Glyph::_nil ();
}

void
GlyphImpl::body (Glyph_ptr g)
{
  body_ = Fresco::Glyph::_duplicate (g);
}

void
GlyphImpl::traverse (Traversal_ptr t)
{
  if (CORBA::is_nil (body_.in()))
    visit (t);
  else
    t->traverse (body_.in());
}

void
GlyphImpl::visit (Traversal_ptr t) {}

void
TraversalImpl::traverse (Glyph_ptr g)
{
  if (!CORBA::is_nil(g))
    {
#ifdef HAVE_POA_CURRENT
      PortableServer::POA_var poa = poacurrent->get_POA ();
      PortableServer::ObjectId_var oid = poacurrent->get_object_id ();
      Traversal_var t = Fresco::Traversal::_narrow (poa->id_to_reference (oid.in()));
      g->traverse (t.in());
#else
      g->traverse (Traversal_var (_this ()));
#endif
    }
}

Glyph_ptr
GlyphFactoryImpl::make_glyph ()
{
  GlyphImpl *impl = new GlyphImpl;
  return impl->_this ();
}

Traversal_ptr
GlyphFactoryImpl::make_traversal ()
{
  TraversalImpl *impl = new TraversalImpl ();
  return impl->_this ();
}
