#ifndef glyph_impl_hh_ 
#define glyph_impl_hh_ 

#ifdef USE_TAO
#include "GlyphC.h"
#include "GlyphS.h"
#endif

#ifdef USE_OMNI
#include "Glyph.hh"
#endif

#ifdef USE_ORBACUS
#include <OB/CORBA.h>
#include "Glyph.h"
#include "Glyph_skel.h"
#endif

using namespace Fresco;

class GlyphImpl : public POA_Fresco::Glyph
{
public:
  GlyphImpl ();

  virtual void body (Glyph_ptr);
  virtual void visit (Traversal_ptr);
  virtual void traverse (Traversal_ptr);
  
protected:
  Glyph_var body_;
};

class TraversalImpl : public POA_Fresco::Traversal
{
public:
  virtual void traverse (Glyph_ptr);
};

class GlyphFactoryImpl : public POA_Fresco::GlyphFactory
{
public:
  virtual Glyph_ptr make_glyph ();
  virtual Traversal_ptr make_traversal ();
};
#endif /*  glyph_impl_hh_  */
