#include <time.h>
#include "Server-impl.h"

/*** Implementation stub prototypes ***/

static void
impl_Fresco_Glyph_body (impl_POA_Fresco_Glyph * servant,
			Fresco_Glyph g, CORBA_Environment * ev);

static void
impl_Fresco_Glyph_traverse (impl_POA_Fresco_Glyph * servant,
			    Fresco_Traversal t, CORBA_Environment * ev);

static void
impl_Fresco_Glyph_visit (impl_POA_Fresco_Glyph * servant,
			 Fresco_Traversal t, CORBA_Environment * ev);

static void impl_Fresco_Traversal_traverse (impl_POA_Fresco_Traversal *
					    servant, Fresco_Glyph g,
					    CORBA_Environment * ev);

static Fresco_Glyph
impl_Fresco_GlyphFactory_make_glyph (impl_POA_Fresco_GlyphFactory * servant,
				     CORBA_Environment * ev);

static Fresco_Traversal
impl_Fresco_GlyphFactory_make_traversal (impl_POA_Fresco_GlyphFactory *
					 servant, CORBA_Environment * ev);

static CORBA_long
impl_Fresco_Screen_traverse (impl_POA_Fresco_Screen * servant,
			     CORBA_long n,
			     Fresco_Traversal t,
			     Fresco_Glyph g, CORBA_Environment * ev);

static Fresco_GlyphFactory
impl_Fresco_Server_get_factory (impl_POA_Fresco_Server * servant,
				CORBA_Environment * ev);

static Fresco_Screen
impl_Fresco_Server_get_screen (impl_POA_Fresco_Server * servant,
			       CORBA_Environment * ev);

/*** epv structures ***/

static PortableServer_ServantBase__epv impl_Fresco_Glyph_base_epv = {
  NULL,				/* _private data */
  NULL,				/* finalize routine */
  NULL,				/* default_POA routine */
};
static POA_Fresco_Glyph__epv impl_Fresco_Glyph_epv = {
  NULL,				/* _private */
  (gpointer) & impl_Fresco_Glyph_body,

  (gpointer) & impl_Fresco_Glyph_traverse,

  (gpointer) & impl_Fresco_Glyph_visit,

};
static PortableServer_ServantBase__epv impl_Fresco_Traversal_base_epv = {
  NULL,				/* _private data */
  NULL,				/* finalize routine */
  NULL,				/* default_POA routine */
};
static POA_Fresco_Traversal__epv impl_Fresco_Traversal_epv = {
  NULL,				/* _private */
  (gpointer) & impl_Fresco_Traversal_traverse,

};
static PortableServer_ServantBase__epv impl_Fresco_GlyphFactory_base_epv = {
  NULL,				/* _private data */
  NULL,				/* finalize routine */
  NULL,				/* default_POA routine */
};
static POA_Fresco_GlyphFactory__epv impl_Fresco_GlyphFactory_epv = {
  NULL,				/* _private */
  (gpointer) & impl_Fresco_GlyphFactory_make_glyph,

  (gpointer) & impl_Fresco_GlyphFactory_make_traversal,

};

static PortableServer_ServantBase__epv impl_Fresco_Screen_base_epv = {
  NULL,				/* _private data */
  NULL,				/* finalize routine */
  NULL,				/* default_POA routine */
};
static POA_Fresco_Screen__epv impl_Fresco_Screen_epv = {
  NULL,				/* _private */
  (gpointer) & impl_Fresco_Screen_traverse,

};
static PortableServer_ServantBase__epv impl_Fresco_Server_base_epv = {
  NULL,				/* _private data */
  NULL,				/* finalize routine */
  NULL,				/* default_POA routine */
};
static POA_Fresco_Server__epv impl_Fresco_Server_epv = {
  NULL,				/* _private */
  (gpointer) & impl_Fresco_Server_get_factory,

  (gpointer) & impl_Fresco_Server_get_screen,

};

/*** vepv structures ***/

static POA_Fresco_Glyph__vepv impl_Fresco_Glyph_vepv = {
  &impl_Fresco_Glyph_base_epv,
  &impl_Fresco_Glyph_epv,
};
static POA_Fresco_Traversal__vepv impl_Fresco_Traversal_vepv = {
  &impl_Fresco_Traversal_base_epv,
  &impl_Fresco_Traversal_epv,
};
static POA_Fresco_GlyphFactory__vepv impl_Fresco_GlyphFactory_vepv = {
  &impl_Fresco_GlyphFactory_base_epv,
  &impl_Fresco_GlyphFactory_epv,
};

static POA_Fresco_Screen__vepv impl_Fresco_Screen_vepv = {
  &impl_Fresco_Screen_base_epv,
  &impl_Fresco_Screen_epv,
};
static POA_Fresco_Server__vepv impl_Fresco_Server_vepv = {
  &impl_Fresco_Server_base_epv,
  &impl_Fresco_Server_epv,
};

/*** Stub implementations ***/

Fresco_Glyph
impl_Fresco_Glyph__create (PortableServer_POA poa, CORBA_Environment * ev)
{
  Fresco_Glyph retval;
  impl_POA_Fresco_Glyph *newservant;
  PortableServer_ObjectId *objid;

  newservant = g_new0 (impl_POA_Fresco_Glyph, 1);
  newservant->servant.vepv = &impl_Fresco_Glyph_vepv;
  newservant->poa = poa;
  newservant->body_ = CORBA_OBJECT_NIL;
  POA_Fresco_Glyph__init ((PortableServer_Servant) newservant, ev);
  objid = PortableServer_POA_activate_object (poa, newservant, ev);
  CORBA_free (objid);
  retval = PortableServer_POA_servant_to_reference (poa, newservant, ev);

  return retval;
}

void
impl_Fresco_Glyph__destroy (impl_POA_Fresco_Glyph * servant,
			    CORBA_Environment * ev)
{
  PortableServer_ObjectId *objid;

  objid = PortableServer_POA_servant_to_id (servant->poa, servant, ev);
  PortableServer_POA_deactivate_object (servant->poa, objid, ev);
  CORBA_free (objid);

  POA_Fresco_Glyph__fini ((PortableServer_Servant) servant, ev);
  g_free (servant);
}

static void
impl_Fresco_Glyph_body (impl_POA_Fresco_Glyph * servant,
			Fresco_Glyph g, CORBA_Environment * ev)
{
  if (!CORBA_Object_is_nil (servant->body_, ev))
    CORBA_Object_release (servant->body_, ev);
  servant->body_ = CORBA_Object_duplicate (g, ev);
}

static void
impl_Fresco_Glyph_traverse (impl_POA_Fresco_Glyph * servant,
			    Fresco_Traversal t, CORBA_Environment * ev)
{
  if (CORBA_Object_is_nil (servant->body_, ev))
    impl_Fresco_Glyph_visit (servant, t, ev);
  else
    Fresco_Traversal_traverse (t, servant->body_, ev);
}

static void
impl_Fresco_Glyph_visit (impl_POA_Fresco_Glyph * servant,
			 Fresco_Traversal t, CORBA_Environment * ev)
{
}

Fresco_Traversal
impl_Fresco_Traversal__create (PortableServer_POA poa, CORBA_Environment * ev)
{
  Fresco_Traversal retval;
  impl_POA_Fresco_Traversal *newservant;
  PortableServer_ObjectId *objid;

  newservant = g_new0 (impl_POA_Fresco_Traversal, 1);
  newservant->servant.vepv = &impl_Fresco_Traversal_vepv;
  newservant->poa = poa;
  POA_Fresco_Traversal__init ((PortableServer_Servant) newservant, ev);
  objid = PortableServer_POA_activate_object (poa, newservant, ev);
  CORBA_free (objid);
  retval = PortableServer_POA_servant_to_reference (poa, newservant, ev);

  return retval;
}

void
impl_Fresco_Traversal__destroy (impl_POA_Fresco_Traversal * servant,
				CORBA_Environment * ev)
{
  PortableServer_ObjectId *objid;

  objid = PortableServer_POA_servant_to_id (servant->poa, servant, ev);
  PortableServer_POA_deactivate_object (servant->poa, objid, ev);
  CORBA_free (objid);

  POA_Fresco_Traversal__fini ((PortableServer_Servant) servant, ev);
  g_free (servant);
}

static void
impl_Fresco_Traversal_traverse (impl_POA_Fresco_Traversal * servant,
				Fresco_Glyph g, CORBA_Environment * ev)
{
}

Fresco_GlyphFactory
impl_Fresco_GlyphFactory__create (PortableServer_POA poa,
				  CORBA_Environment * ev)
{
  Fresco_GlyphFactory retval;
  impl_POA_Fresco_GlyphFactory *newservant;
  PortableServer_ObjectId *objid;

  newservant = g_new0 (impl_POA_Fresco_GlyphFactory, 1);
  newservant->servant.vepv = &impl_Fresco_GlyphFactory_vepv;
  newservant->poa = poa;
  POA_Fresco_GlyphFactory__init ((PortableServer_Servant) newservant, ev);
  objid = PortableServer_POA_activate_object (poa, newservant, ev);
  CORBA_free (objid);
  retval = PortableServer_POA_servant_to_reference (poa, newservant, ev);

  return retval;
}

void
impl_Fresco_GlyphFactory__destroy (impl_POA_Fresco_GlyphFactory * servant,
				   CORBA_Environment * ev)
{
  PortableServer_ObjectId *objid;

  objid = PortableServer_POA_servant_to_id (servant->poa, servant, ev);
  PortableServer_POA_deactivate_object (servant->poa, objid, ev);
  CORBA_free (objid);

  POA_Fresco_GlyphFactory__fini ((PortableServer_Servant) servant, ev);
  g_free (servant);
}

static Fresco_Glyph
impl_Fresco_GlyphFactory_make_glyph (impl_POA_Fresco_GlyphFactory * servant,
				     CORBA_Environment * ev)
{
  return impl_Fresco_Glyph__create (servant->poa, ev);
}

static Fresco_Traversal
impl_Fresco_GlyphFactory_make_traversal (impl_POA_Fresco_GlyphFactory *
					 servant, CORBA_Environment * ev)
{
  return impl_Fresco_Traversal__create (servant->poa, ev);
}

Fresco_Screen
impl_Fresco_Screen__create (PortableServer_POA poa, CORBA_Environment * ev)
{
  Fresco_Screen retval;
  impl_POA_Fresco_Screen *newservant;
  PortableServer_ObjectId *objid;

  newservant = g_new0 (impl_POA_Fresco_Screen, 1);
  newservant->servant.vepv = &impl_Fresco_Screen_vepv;
  newservant->poa = poa;
  POA_Fresco_Screen__init ((PortableServer_Servant) newservant, ev);
  objid = PortableServer_POA_activate_object (poa, newservant, ev);
  CORBA_free (objid);
  retval = PortableServer_POA_servant_to_reference (poa, newservant, ev);

  return retval;
}

void
impl_Fresco_Screen__destroy (impl_POA_Fresco_Screen * servant,
			     CORBA_Environment * ev)
{
  PortableServer_ObjectId *objid;

  objid = PortableServer_POA_servant_to_id (servant->poa, servant, ev);
  PortableServer_POA_deactivate_object (servant->poa, objid, ev);
  CORBA_free (objid);

  POA_Fresco_Screen__fini ((PortableServer_Servant) servant, ev);
  g_free (servant);
}

static CORBA_long
impl_Fresco_Screen_traverse (impl_POA_Fresco_Screen * servant,
			     CORBA_long n,
			     Fresco_Traversal t,
			     Fresco_Glyph g, CORBA_Environment * ev)
{
  CORBA_long i;

  time_t start, end;

  if (CORBA_Object_is_nil (g, ev) || CORBA_Object_is_nil (t, ev))
    return -1;

  start = time (0);
  for (i = 0; i < n; i++)
    Fresco_Traversal_traverse (t, g, ev);
  end = time (0);

  return (CORBA_long) (end - start);
}

Fresco_Server
impl_Fresco_Server__create (PortableServer_POA poa, CORBA_Environment * ev)
{
  Fresco_Server retval;
  impl_POA_Fresco_Server *newservant;
  PortableServer_ObjectId *objid;

  newservant = g_new0 (impl_POA_Fresco_Server, 1);
  newservant->servant.vepv = &impl_Fresco_Server_vepv;
  newservant->poa = poa;
  newservant->factory_ = impl_Fresco_GlyphFactory__create (poa, ev);
  newservant->screen_ = impl_Fresco_Screen__create (poa, ev);
  POA_Fresco_Server__init ((PortableServer_Servant) newservant, ev);
  objid = PortableServer_POA_activate_object (poa, newservant, ev);
  CORBA_free (objid);
  retval = PortableServer_POA_servant_to_reference (poa, newservant, ev);

  return retval;
}

void
impl_Fresco_Server__destroy (impl_POA_Fresco_Server * servant,
			     CORBA_Environment * ev)
{
  PortableServer_ObjectId *objid;

  objid = PortableServer_POA_servant_to_id (servant->poa, servant, ev);
  PortableServer_POA_deactivate_object (servant->poa, objid, ev);
  CORBA_free (objid);

  POA_Fresco_Server__fini ((PortableServer_Servant) servant, ev);
  g_free (servant);
}

static Fresco_GlyphFactory
impl_Fresco_Server_get_factory (impl_POA_Fresco_Server * servant,
				CORBA_Environment * ev)
{
  return CORBA_Object_duplicate (servant->factory_, ev);
}

static Fresco_Screen
impl_Fresco_Server_get_screen (impl_POA_Fresco_Server * servant,
			       CORBA_Environment * ev)
{
  return CORBA_Object_duplicate (servant->screen_, ev);
}
