#include "ServerImpl.hh"
#include "GlyphImpl.hh"

#include <time.h>

CORBA::Long
ScreenImpl::traverse (CORBA::Long n, Traversal_ptr t, Glyph_ptr g)
{
  CORBA::Long i;

  time_t start, end;

  if (CORBA::is_nil (g) || CORBA::is_nil (t))
    return -1;

  start = time (0);
  for (i = 0; i < n; i++)
    t->traverse (g);
  end = time (0);

  return CORBA::Long (end - start);
}

ServerImpl::ServerImpl ()
{
  GlyphFactoryImpl *fact = new GlyphFactoryImpl;
  factory_ = fact->_this ();

  ScreenImpl *scrn = new ScreenImpl;
  screen_ = scrn->_this ();
}

GlyphFactory_ptr
ServerImpl::get_factory ()
{
  return GlyphFactory::_duplicate (factory_.in());
}

Screen_ptr
ServerImpl::get_screen ()
{
  return Screen::_duplicate (screen_.in());
}

