#include "Server.h"
#include <stdio.h>

#define SCENE_DEPTH 100
#define LOOP_COUNT 10000

int main (int argc, char* argv[])
{
  CORBA_long i;
  CORBA_ORB orb;
  CORBA_Environment ev;
  Fresco_Server server;
  Fresco_Screen screen;
  Fresco_GlyphFactory factory;
  Fresco_Traversal t;
  Fresco_Glyph head, g;

  orb = CORBA_ORB_init (&argc, argv, "orbit-local-orb", &ev);

  server = CORBA_ORB_string_to_object (orb, argv[1], &ev);
  screen = Fresco_Server_get_screen (server, &ev);
  factory = Fresco_Server_get_factory (server, &ev);
  t = Fresco_GlyphFactory_make_traversal (factory, &ev);

  head = Fresco_GlyphFactory_make_glyph (factory, &ev);
  g = (Fresco_Glyph) CORBA_Object_duplicate (head, &ev);
  for (i = 0; i < SCENE_DEPTH; i++)
    {
      Fresco_Glyph c;
      c = Fresco_GlyphFactory_make_glyph (factory, &ev);
      Fresco_Glyph_body (g, c, &ev);
      CORBA_Object_release (g, &ev);
      g = c;
    }

  printf ("Time: %ld\n", Fresco_Screen_traverse (screen, LOOP_COUNT / 100, t, head, &ev));
  printf ("Time: %ld\n", Fresco_Screen_traverse (screen, LOOP_COUNT / 50, t, head, &ev));
  printf ("Time: %ld\n", Fresco_Screen_traverse (screen, LOOP_COUNT / 10, t, head, &ev));
  printf ("Time: %ld\n", Fresco_Screen_traverse (screen, LOOP_COUNT, t, head, &ev));

  return 0;
}
