#include <fstream>
#include <signal.h>
#include "ServerImpl.hh"

#ifdef HAVE_POA_CURRENT
PortableServer::Current_var poacurrent = PortableServer::Current::_nil ();
#endif

int main (int argc, char* argv[])
{
  // Initialize the CORBA orb
  CORBA::ORB_var orb = CORBA::ORB_init (argc, argv);
	
  // Get the root POA
  CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
  PortableServer::POA_var rootPOA = PortableServer::POA::_narrow(obj.in());

#ifdef HAVE_POA_CURRENT
  obj = orb->resolve_initial_references ("POACurrent");
  poacurrent = PortableServer::Current::_narrow (obj.in());
#endif

  // Activate the root POA's manager
  PortableServer::POAManager_var mgr = rootPOA->the_POAManager();
  mgr->activate();

  // Create the server.  
  ServerImpl *srv = new ServerImpl;
  CORBA::Object_var objref = srv->_this ();

  // Public the server IOR.  
  CORBA::String_var ior = orb->object_to_string (objref.in());
  
  // write the ior out to a file
  ofstream out("iorfile");
  out << ior << flush;
  
  // Run the ORB event loop
  orb->run();
}
